#include <cxxtls/commandLineOptions.h>
#include <cxxtls/foreach.h>

using namespace std;
using namespace cxxtls;
using namespace CommandLine;

std::ostream &operator<<(std::ostream &s, Options const &rhs)
{
    s << "Options\n";

    OptionDeclaration const* opts  = &rhs.info()[0];
    size_t                   count = rhs.info().size();

    while(count--)
    {
       s << "   " << opts->name_ ;

       vector<string> const &values = rhs.flagValue(opts->name_);

       CXXTLS_FOREACH(string const &cur, values)
       {
           s << "  "  << cur;
       }


       s << '\n';

       ++opts;
    }

    s << "Arguments\n";

    for(size_t i = 0; i < rhs.size(); ++i)
       s << "   " << i << "  " << rhs.arg(i) << '\n';

    return s;
}


int main(int arg, char **argv)
try
{
     static OptionDeclaration allowedOptions[] =
     {
         { "a", 0, 0, "The x option" },
         { "b", 0, 0, "The x option" },
         { "c", 0, 0, "The x option" },
         { "tom", 0, 1, "The x option" },
         { "dick", 0, 1, "The x option" },
         { "harry", 0, 1, "The x option" },
         { "sally", 0, 1, "The x option" },
         { "v", 1, 0, "The x option" },
         { "t", 2, 0, "The x option" },
         { "File", 2, 1, "The x option" },
         { "Single", 1, 1, "The x option" },
         { "I", 2, 0, "The x option"},
     };


     Options  opts(argv, allowedOptions, sizeof(allowedOptions) / sizeof(allowedOptions[0]) );

     cout << opts << endl;

     cout << "\nTesting flags" << endl;

     cout << "  flag a? " << opts.isSet("a") << endl;
     cout << "  flag b? " << opts.isSet("b") << endl;
     cout << "  flag c? " << opts.isSet("c") << endl;
     cout << "  flag tom? " << opts.isSet("tom") << endl;
     cout << "  flag dick? " << opts.isSet("dick") << endl;
     cout << "  flag harry? " << opts.isSet("harry") << endl;
     cout << "  flag sally? " << opts.isSet("sally") << endl;
     cout << "  flag File?"   << opts.isSet("File") << endl;
     cout << "  flag Single?"   << opts.isSet("Single") << endl;

     cout << "Option Help\n";

     opts.printHelp(cout);


}
catch(std::exception const &e)
{
   cerr << "An exception has occurred:  " << e.what() << endl;
}

