#include <iostream>
#include <cxxtls/simple_regex.h>
#include <stdlib.h>

using namespace std;

int main(int argc, char **argv)
{
    char options[3];

    options[0] = ' ';  // extended: use 'e'
    options[1] = 'i';  // case insenstive by default
    options[2] = 0;


    if(argc > 1 && string("-e") == argv[1])
    {
       ++argv;
       --argc;

       options[0] = 'e';

    }


    if(argc < 3)
    {
       cerr << "rt command line error:  expected a regular expression and a string to test against\n";
       exit(1);
    }

    cxxtls::SimpleRegex regex(argv[1], options);

    string   comparand(argv[2]);

    int matched = regex(comparand);

    cout << "Regular Expression:  '" << argv[1] << "'\n";

    cout << "\n";

    cout << "Matched           : " << (matched?"YES":"NO") << '\n';


    cout << "Comparand String  :  '" << argv[2] << "'\n";

    const cxxtls::SimpleRegex::match *matches = regex.matches();

    for(int i = 0; matches && i < matched; ++i)
    {
        int offset = matches[i].offset;
        int length = matches[i].length;

        cout << "[" << i << "]";

        cout << "               :  '";

        for(int tmp=0; tmp < offset; ++tmp)  cout << ' ';

        for(int charNo = 0;  charNo < length; ++charNo)
            cout << comparand[offset + charNo];
        

        cout << "\n";



    }


    cout << "\n\n";
    
     
}
