
//
// Copyright 2010, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.


//@File
//
///   This file defines a test for the Viewer class by creating a
///   trivial application that creates a single viewer.

#include <cxxtls/scripttableviewer.h>
#include <cxxtls/viewermanager.h>
#include <iostream>
#include <stdlib.h>
#include <string>


using namespace std;
using namespace cxxtls;

char const *script="../STV/dir.sh";


int main(int argc, char **argv)
{
  if(argc > 1)
    script = argv[1];

  ViewerManager vm;

  vm.open();

  ScriptTableViewer *p;
  
  p = new ScriptTableViewer(&vm,script);


  string tmp = p->application_name();


  vm.add(p, "STV" );

  (*p)(vm.active_viewport(), CursorWindow::viewport::repaint_handler::activate);

  vm.run();



}

