#include <cxxtls/utf.h>
#include <cxxtls/file.h>
#include <string>
#include <fstream>
#include <stdlib.h>
#include <iostream>

using namespace std;
using namespace cxxtls;


void bomb(char const *msg, size_t value=0)
{
   cerr << msg << ':' << value << endl;
   exit(1);
}


int main(int argc, char **argv)
{
    ++argv;


    while(*argv)
    {
        char const *arg = *argv++;

        FileName file(arg);

        FileContents contents;

        file.slurp(&contents);

        if(!contents.ok())
        {
           cerr << "Error:  cannot open file " << file << endl;
           continue;
        }

        FileContents::const_iterator f = contents.begin(), l = contents.end();

        utf::encoding type = utf::utfunk_enc;


        if(f != l)
        {
            type = utf::streamEncoding(f, l);

            if(      type != utf::utf16be_enc
               &&    type != utf::utf16le_enc
              )
            {
                cerr << "Error: unsupported encoding for file " << file << ", type is " << utf::encodingName(type) << endl;
                continue;
            }
        }

        if(type == utf::utf16be_enc)
        {
            utf::decoder<utf::utf16be_enc> decoder;

            while(f != l)
            {
                wchar_t utfChar = decoder(f,l);

                if(utfChar == wchar_t(-1))
                {
                   bomb("invalid character incoding");
                }


                cout << utf::conflate(utfChar);

            }
        }
        else
        {
            utf::decoder<utf::utf16le_enc> decoder;

            while(f != l)
            {
                wchar_t utfChar = decoder(f,l);

                if(utfChar == wchar_t(-1))
                {
                   bomb("invalid character incoding");
                }


                cout << utf::conflate(utfChar);

            }
        }



    }
}
