#include <cxxtls/cubic_spline.h>
#include <iostream>
#include <cxxtls/ascii_chart.h>
#include <vector>
#include <math.h>

using namespace std;
using namespace cxxtls;

int main()
{
  cout << "Cubic spline test begins" << endl;

  {

    static pair<double, double> tmp[] =
    {
      pair<double,double>(10,00),
      pair<double,double>(20,10),
      pair<double,double>(30,00),
      pair<double,double>(40,-10),
      pair<double,double>(50,00)
    };
    
    int count = sizeof(tmp)/sizeof(tmp[0]);
    
    cubic_spline s(tmp, tmp+count);
    
    ascii_chart chart(70,40);
    
    vector< pair<double,double> > points(70);
    
    s.evaluate(0,1, points.begin(), points.end());
    
    chart.plot(points);
    
    chart.title_ = "Sinusoidal data set";
    
    cout << chart;

  }


  {
    static pair<double, double> tmp[] =
    {
      pair<double,double>(0,01),
      pair<double,double>(1,02),
      pair<double,double>(2,04),
      pair<double,double>(3, 8),
      pair<double,double>(4,16),
      pair<double,double>(5,32),
    };
    
    int count = sizeof(tmp)/sizeof(tmp[0]);
    
    cubic_spline s(tmp, tmp+count);
    
    ascii_chart chart(70,40);
    
    vector< pair<double,double> > points(6);
    
    s.evaluate(0,1, points.begin(), points.end());
    
    chart.plot(points);
    
    chart.title_ = "2 ^^ X";
    
    cout << chart;

  }

  {
    vector< pair<double, double> > tmp;

    int i;

    for(i=1; i < 10; ++i)
    {
       double d = double(i);

       double l = log(d);

       tmp.push_back( pair<double,double>(d,l) );

    }
    
    cubic_spline s(tmp.begin(), tmp.end());
    
    ascii_chart chart(70,40);
    
    vector< pair<double,double> > points(50);
    
    s.evaluate(0,0.2, points.begin(), points.end());
    
    chart.plot(points);
    
    chart.title_ = "log(x)";
    
    cout << chart;

  }


}
