#include <cxxtls/spline.h>
#include <iostream>
#include <algorithm>
#include <cxxtls/ascii_chart.h>
#include <vector>

using namespace std;
using namespace cxxtls;

typedef spline<float,float>          Function;
typedef vector< pair<float,float> >  values_t;


int main(int argc, char **argv)
{
   Function f1;

   f1.add_sample(00,00);
   f1.add_sample(17,10);
   f1.add_sample(31,00);
   f1.add_sample(48,-10);
   f1.add_sample(62,00);

   ascii_chart chart(70, 20);

   values_t values(70);  

   chart.title_ = "step function";
   f1.evaluate(0,1,values.begin(), values.end());
   chart.plot(values);
   cout << chart;

   chart.clear();
   chart.title_ = "linear function";
   f1.set_interpolator(&Function::interpolate_line);
   f1.evaluate(0,1,values.begin(), values.end());
   chart.plot(values);
   cout << chart;

   chart.clear();
   chart.title_ = "cubic function";
   f1.set_interpolator(&Function::interpolate_cubic);
   f1.evaluate(0,1,values.begin(), values.end());
   chart.plot(values);
   cout << chart;


}
