#include "cxxtls/muSED.h"
#include <cxxtls/file.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>

using namespace std;
using namespace cxxtls;
using namespace muSED;

static void readFile(string filename, list<string> &output)
{
   ifstream  f(filename.c_str());

   string line;

   int lines=0;

   while(std::getline(f, line))
   {
      ++lines;
      output.push_back(line);
   }

   if(lines == 0)
   {
       cerr << "Error:  unable to read file " << filename << endl;
       exit(1);
   }

}

int main(int argc, char **argv)
{
   cout << "muSED test program begins!\n" << endl;

   if( argc != 3 )
   {
       cerr << "mused error:  expected script name and file name on the command line" << endl;
       exit(1);
   }


   std::list<std::string> script;

   readFile(argv[1], script);

   int line;


   cout << "SCRIPT" << endl;

   line=0;
   CXXTLS_FOREACH(std::string const &cur, script)
   {
      cout << "    script data[" << ++line << "]=" << cur << endl;
   }



   CompiledScript       compiledScript(script); 

   if(!compiledScript.ok())
   {
      cout << "ERROR: SCRIPT COMPILATION FAILURE" << endl;
      cout << "       ERROR = " << compiledScript.error() << endl;
      exit(1);
   }


   std::list<std::string> document;

   readFile(argv[2], document);

   cout << "INPUT DOCUMENT" << endl;

   line=0;
   CXXTLS_FOREACH(std::string const &cur, document)
   {
      cout << "    input data[" << ++line << "]=" << cur << endl;
   }

   std::list<std::string> output;


   std::string error =apply(compiledScript, document, output);

   if(!error.empty())
   {
       cout << "ERROR:  EXECUTION FAILED!  " << error << endl;
       exit(1);
   }

   cout << "CONVERTED OUTPUT" << endl;


   line=0;
   CXXTLS_FOREACH(std::string const &cur, output)
   {
      cout << "    output data[" << ++line << "]=" << cur << endl;
   }

   cout << "muSED test program ENDS" << endl;

      exit(0);
}
