#include <cxxtls/muSED.h>
#include <iostream>
#include <stdlib.h>

using namespace cxxtls;
using namespace std;



#ifdef __GNUC__
#   if __GNUC__ > 4 || ( __GNUC__ == 4 &&  __GNUC_MINOR__ > 2 )
#       define USE_muSED
#   endif
#else
#   define USE_muSED
#endif



#ifdef USE_muSED

int main()
{
    // this program just performs some internal testing to verify that
    // expected muSED::apply functions compile correctly


    {
        std::list<std::string> input;
        std::list<std::string> output;

        input.push_back("one");

        std::list<std::string>  script;

        script.push_back("s/one/two/g;p");

        muSED::apply(script, input, output);

        if(output.size() != 1)
        {
           cerr << "muSED_test FAILED 'muSED::apply(scriptContainter, inputContainter, outputContainer)'" << endl;
           cerr << "                  expected output.size() to be 1, but found " << output.size() << endl;
           exit(1);
        }

        if(*output.begin() != "two")
        {
           cerr << "muSED_test FAILED 'muSED::apply(scriptContainter, inputContainter, outputContainer)'" << endl;
           cerr << "                  expected 'two' but found " << *output.begin() << endl;
           exit(1);
        }


    }

    {
        std::list<std::string> input;
        std::list<std::string> output;

        input.push_back("one");


        muSED::oneLiner("s/one/two/1;p", input, output);

        if(output.size() != 1)
        {
           cerr << "muSED_test FAILED 'muSED::apply(std::string, inputContainter, outputContainer)'" << endl;
           cerr << "                  expected output.size() to be 1, but found " << output.size() << endl;
           exit(1);
        }

        if(*output.begin() != "two")
        {
           cerr << "muSED_test FAILED 'muSED::apply(std::string, inputContainter, outputContainer)'" << endl;
           cerr << "                  expected 'two' but found " << *output.begin() << endl;
           exit(1);
        }

    }


    cerr << "muSED_test PASSED" << endl;

}
#else
    int main() { cout << "muSED_test not needed on this platform" << endl; return 0; }
#endif
