#include <iostream>
#include <cxxtls/stringexpression.h>
#include <cxxtls/stringexpressionparser.h>


using namespace std;
using namespace cxxtls;

typedef std::list< StringExpression * > ExpressionList;

int main()
{

   cout << "StringExpression test program begins" << endl;

   std::string line;

   ExpressionList expressions;

   while(std::getline(cin, line))
   {
       std::string::iterator first(line.begin());
       std::string::iterator last(line.end());

       cout << "Input(" << line << ")";
       
       expressions.push_back( StringExpr::parse(first, last) );

       StringExpression* e = expressions.back();

       if(first != last)
       {
           cout << "-- unparsed ->";
           while(first != last)
              cout << *first++;
           cout << "<-";
       }
       cout << endl;

       if(!e )
       {
          cerr << "Syntax Error:  in(" << line << ")" << endl;
       }
       else
       {
          cout << "     [" << *e << "]" << endl;;
       }

   }

   for(ExpressionList::iterator f = expressions.begin(); f != expressions.end(); ++f)
   {
      delete *f++;
   }

}
