
//
// Copyright 2002, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.



#include <cxxtls/cursorwindow.h>
#include <iostream>
#include <portable_io.h>
#include <stdlib.h>
#include <iomanip>

using namespace std;
using namespace cxxtls;

class ResizeHandler
: public CursorWindow::resize_handler
{
public:

   void operator() (CursorWindow* w)
   {
     // paint the window

      CursorWindow::row_col size = w->size();

      w->set_text_attribute(CursorWindow::normal);

      if(size.row_ < 1 || size.row_ > 200)
	cout << "window rows is way off" << endl;

      if(size.col_ < 1 || size.col_ > 200)
	cout << "window cols is way off" << endl;

      int i;

      for(i=0; i < size.row_; ++i)
      {
	 char buffer[40];

	 sprintf(buffer, "row %d", i);

	 w->set_curpos(i,0);

	 w->write(buffer);

      }


      w->set_text_attribute(CursorWindow::reversed);

      w->set_curpos(0,0);
      w->write("*");
      w->set_curpos(size.row_-1, 0);
      w->write("*");
      w->set_curpos(0, size.col_-1);
      w->write("*");
      w->set_curpos(size.row_-1, size.col_-1);
      w->write("*");

      w->set_curpos(10,10);

   }
};


int main()
{
  {
    CursorWindow w;

    w.open();

    ResizeHandler h;

    h(&w);

    w.set_resize_handler(&h);

    for(;;)
    {
      CursorWindow::input_event e = w.read_input();

      if(e.value_ == ' ')
	break;

      w.set_curpos(10,10);
      w << std::setw(20) << "";
      w.set_curpos(10,10);

      {
	static int count=0;

	++count;

	// char buffer[40];
	//
	// sprintf(buffer, "[%2d]", count);
	//
	// w.write(buffer);

	w << std::setw(12)
	  << CursorWindow::key_name(e.value_)
	  << "[" << std::setw(2) << count << "]" ;

      }

      if(e.value_ == 'b')
      {
	w.box(20, 10, 1, "stuff");
      }


    }

    std::cout << std::flush;

    fflush(stdout);

  }
  exit(0);
}
