#include <iostream>
#include <cxxtls/etagsdb.h>

using namespace std;
using namespace cxxtls;

int main(int argc, char **argv)
{
  if(argc != 3)
  {
    return 0;
  }

  EtagsDB db(argv[2]);

  std::string symbol(argv[1]);
  std::string filename;
  int         linenumber;
  std::string matching_text;

  int rv = db.find_first(symbol, &filename, &linenumber, &matching_text);

  while(rv)
  {
    cout << "Match at \"" << filename << "\", line " << linenumber << " '"
	 << matching_text << endl;
	
    rv = db.find_next(&filename, &linenumber, &matching_text);
  }

  {
    list<string> matches;

    int count = db.matching_files("", &matches);

    list<string>::iterator f, l;

    cout << endl;

    cout << "Found " << count << " files in the database, they are:" << endl; 

    for(f=matches.begin(), l = matches.end(); f != l; ++f)
    {
      cout << "  " << *f << endl;
    }

    cout << endl;

    matches.erase(matches.begin(), matches.end());

    count = db.matching_files("test_stat.c", &matches);

    cout << "Found " << count << " matches for 'test_stat.c'" << endl;

    for(f=matches.begin(), l = matches.end(); f != l; ++f)
    {
      cout << "  " << *f << endl;
    }


    cout << endl;

    matches.erase(matches.begin(), matches.end());

    count = db.matching_files("c:/test_stat.c", &matches);

    cout << "Found " << count << " matches for 'c:/test_stat.c'" << endl;

    for(f=matches.begin(), l = matches.end(); f != l; ++f)
    {
      cout << "  " << *f << endl;
    }


    cout << endl;

    matches.erase(matches.begin(), matches.end());

    count = db.matching_files("/dir/test_stat.c", &matches);

    cout << "Found " << count << " matches for '/dir/test_stat.c'" << endl;

    for(f=matches.begin(), l = matches.end(); f != l; ++f)
    {
      cout << "  " << *f << endl;
    }


    cout << endl;

    matches.erase(matches.begin(), matches.end());

    count = db.matching_files("four/four.c", &matches);

    cout << "Found " << count << " matches for 'four/four.c'" << endl;

    for(f=matches.begin(), l = matches.end(); f != l; ++f)
    {
      cout << "  " << *f << endl;
    }



  }


}
