#include <cxxtls/fmtd.h>

#include <string>
#include <iomanip> // not needed for fmtd

using namespace std;
using namespace cxxtls;


int main()
{
   int           intvar  = 37;
   int           intneg  = -37;
   short       shortvar  = 38;
   unsigned unsignedvar  = 39;
   long         longvar  = 40;
   long long    llvar    = 41;
   unsigned long ulvar   = 42;
   unsigned long long UX = 43;
   char const        *ptr= "constChar";
   string             str= "string";
   


#define DEFAULT_LOG(V) cout << "    Formatted version of " << setw(10) << V << " is '" << fmtd<>(V) << "'" << endl
#define LJUST_LOG(pad, V) cout << "    Formatted version of " << setw(10) << V << " is '" << fmtd<-20,0,pad>(V) << "'" << endl
#define PLJUST_LOG(pad, V) cout << "    Formatted version of " << setw(10) << V << " is '" << fmtd<-20,10,pad>(V) << "'" << endl
#define RJUST_LOG(pad, V) cout << "    Formatted version of " << setw(10) << V << " is '" << fmtd<20,0,pad>(V) << "'" << endl
#define RPJUST_LOG(pad, V) cout << "    Formatted version of " << setw(10) << V << " is '" << fmtd<20,10,pad>(V) << "'" << endl

cout << "=================================================" << endl;
cout << "Unjustified integers" << endl;

   DEFAULT_LOG(intvar);
   DEFAULT_LOG(intneg);
   DEFAULT_LOG(shortvar);
   DEFAULT_LOG(unsignedvar);
   DEFAULT_LOG(longvar);
   DEFAULT_LOG(llvar);
   DEFAULT_LOG(ulvar);
   DEFAULT_LOG(UX);
   DEFAULT_LOG(ptr);
   DEFAULT_LOG(str);


cout << "Left justified, zero padded integers" << endl;


   LJUST_LOG('0',intvar);
   LJUST_LOG('0',intneg);
   LJUST_LOG('0',shortvar);
   LJUST_LOG('0',unsignedvar);
   LJUST_LOG('0',llvar);
   LJUST_LOG('0',longvar);
   LJUST_LOG('0',ulvar);
   LJUST_LOG('0',UX);
   LJUST_LOG('0',ptr);
   LJUST_LOG('0',str);

cout << "Left justified, space  padded integers" << endl;

   LJUST_LOG(' ',intvar);
   LJUST_LOG(' ',intneg);
   LJUST_LOG(' ',shortvar);
   LJUST_LOG(' ',unsignedvar);
   LJUST_LOG(' ',longvar);
   LJUST_LOG(' ',llvar);
   LJUST_LOG(' ',ulvar);
   LJUST_LOG(' ',UX);
   LJUST_LOG(' ',ptr);
   LJUST_LOG(' ',str);

cout << "Right justified, zero padded integers" << endl;


   RJUST_LOG('0',intvar);
   RJUST_LOG('0',intneg);
   RJUST_LOG('0',shortvar);
   RJUST_LOG('0',unsignedvar);
   RJUST_LOG('0',longvar);
   RJUST_LOG('0',llvar);
   RJUST_LOG('0',ulvar);
   RJUST_LOG('0',UX);
   RJUST_LOG('0', ptr);
   RJUST_LOG('0', str);

cout << "Right justified, space  padded integers" << endl;

   RJUST_LOG(' ',intvar);
   RJUST_LOG(' ',intneg);
   RJUST_LOG(' ',shortvar);
   RJUST_LOG(' ',unsignedvar);
   RJUST_LOG(' ',longvar);
   RJUST_LOG(' ',llvar);
   RJUST_LOG(' ',ulvar);
   RJUST_LOG(' ',UX);
   RJUST_LOG(' ',ptr);
   RJUST_LOG(' ',str);

/////////////////////////////////////////

cout << "=================================================" << endl;
cout << "Unjustified (floats)" << endl;

   float floatf1=-99;


   DEFAULT_LOG(floatf1);

   DEFAULT_LOG((float)intvar);
   DEFAULT_LOG((float)intneg);
   DEFAULT_LOG((float)shortvar);
   DEFAULT_LOG((float)unsignedvar);
   DEFAULT_LOG((float)longvar);
   DEFAULT_LOG((float)llvar);
   DEFAULT_LOG((float)ulvar);
   DEFAULT_LOG((float)UX);
   DEFAULT_LOG(1e37);


cout << "Left justified, zero padded floats" << endl;


   LJUST_LOG('0',(float)intvar);
   LJUST_LOG('0',(float)intneg);
   LJUST_LOG('0',(float)shortvar);
   LJUST_LOG('0',(float)unsignedvar);
   LJUST_LOG('0',(float)longvar);
   LJUST_LOG('0',(float)llvar);
   LJUST_LOG('0',(float)ulvar);
   LJUST_LOG('0',(float)UX);
   LJUST_LOG('0',(float)1e37);

cout << "Left justified, space  padded floats" << endl;

   LJUST_LOG(' ',(float)intvar);
   LJUST_LOG(' ',(float)intneg);
   LJUST_LOG(' ',(float)shortvar);
   LJUST_LOG(' ',(float)unsignedvar);
   LJUST_LOG(' ',(float)longvar);
   LJUST_LOG(' ',(float)llvar);
   LJUST_LOG(' ',(float)ulvar);
   LJUST_LOG(' ',(float)UX);
   LJUST_LOG(' ',(float)1e37);

cout << "Right justified, zero padded floats" << endl;


   RJUST_LOG('0',(float)intvar);
   RJUST_LOG('0',(float)intneg);
   RJUST_LOG('0',(float)shortvar);
   RJUST_LOG('0',(float)unsignedvar);
   RJUST_LOG('0',(float)longvar);
   RJUST_LOG('0',(float)llvar);
   RJUST_LOG('0',(float)ulvar);
   RJUST_LOG('0',(float)UX);
   RJUST_LOG('0',(float)1e37);

cout << "Right justified, space  padded floats" << endl;

   RJUST_LOG(' ',(float)intvar);
   RJUST_LOG(' ',(float)intneg);
   RJUST_LOG(' ',(float)shortvar);
   RJUST_LOG(' ',(float)unsignedvar);
   RJUST_LOG(' ',(float)longvar);
   RJUST_LOG(' ',(float)llvar);
   RJUST_LOG(' ',(float)ulvar);
   RJUST_LOG(' ',(float)UX);
   RJUST_LOG(' ',(float)1e37);

////////////////////////////////
/////////////////////////////////
cout << "=================================================" << endl;
cout << "Unjustified (double)" << endl;

   float doublef1=-99;


   DEFAULT_LOG(doublef1);

   DEFAULT_LOG((double)intvar);
   DEFAULT_LOG((double)intneg);
   DEFAULT_LOG((double)shortvar);
   DEFAULT_LOG((double)unsignedvar);
   DEFAULT_LOG((double)longvar);
   DEFAULT_LOG((double)llvar);
   DEFAULT_LOG((double)ulvar);
   DEFAULT_LOG((double)UX);
   DEFAULT_LOG((double)1e37);


cout << "Left justified, zero padded floats" << endl;


   LJUST_LOG('0',(double)intvar);
   LJUST_LOG('0',(double)intneg);
   LJUST_LOG('0',(double)shortvar);
   LJUST_LOG('0',(double)unsignedvar);
   LJUST_LOG('0',(double)longvar);
   LJUST_LOG('0',(double)llvar);
   LJUST_LOG('0',(double)ulvar);
   LJUST_LOG('0',(double)UX);
   LJUST_LOG('0',(double)1e37);

cout << "Left justified, space  padded floats" << endl;

   LJUST_LOG(' ',(double)intvar);
   LJUST_LOG(' ',(double)intneg);
   LJUST_LOG(' ',(double)shortvar);
   LJUST_LOG(' ',(double)unsignedvar);
   LJUST_LOG(' ',(double)longvar);
   LJUST_LOG(' ',(double)llvar);
   LJUST_LOG(' ',(double)ulvar);
   LJUST_LOG(' ',(double)UX);
   LJUST_LOG(' ',(double)1e37);

cout << "Right justified, zero padded floats" << endl;


   RJUST_LOG('0',(double)intvar);
   RJUST_LOG('0',(double)intneg);
   RJUST_LOG('0',(double)shortvar);
   RJUST_LOG('0',(double)unsignedvar);
   RJUST_LOG('0',(double)longvar);
   RJUST_LOG('0',(double)llvar);
   RJUST_LOG('0',(double)ulvar);
   RJUST_LOG('0',(double)UX);
   RJUST_LOG('0',(double)1e37);

cout << "Right justified, space  padded floats" << endl;

   RJUST_LOG(' ',(double)intvar);
   RJUST_LOG(' ',(double)intneg);
   RJUST_LOG(' ',(double)shortvar);
   RJUST_LOG(' ',(double)unsignedvar);
   RJUST_LOG(' ',(double)longvar);
   RJUST_LOG(' ',(double)llvar);
   RJUST_LOG(' ',(double)ulvar);
   RJUST_LOG(' ',(double)UX);
   RJUST_LOG(' ',(double)1e37);

////////////////////////////////
/////////////////////////////////
cout << "=================================================" << endl;
cout << "Unjustified (long double)" << endl;

   long double ldf1=-99;


   DEFAULT_LOG(ldf1);

   DEFAULT_LOG((long double)intvar);
   DEFAULT_LOG((long double)intneg);
   DEFAULT_LOG((long double)shortvar);
   DEFAULT_LOG((long double)unsignedvar);
   DEFAULT_LOG((long double)longvar);
   DEFAULT_LOG((long double)llvar);
   DEFAULT_LOG((long double)ulvar);
   DEFAULT_LOG((long double)UX);
   DEFAULT_LOG((long double)1e37);


cout << "Left justified, zero padded floats" << endl;


   LJUST_LOG('0',(long double)intvar);
   LJUST_LOG('0',(long double)intneg);
   LJUST_LOG('0',(long double)shortvar);
   LJUST_LOG('0',(long double)unsignedvar);
   LJUST_LOG('0',(long double)longvar);
   LJUST_LOG('0',(long double)llvar);
   LJUST_LOG('0',(long double)ulvar);
   LJUST_LOG('0',(long double)UX);
   LJUST_LOG('0',(long double)1e37);

cout << "Left justified, space  padded floats" << endl;

   LJUST_LOG(' ',(long double)intvar);
   LJUST_LOG(' ',(long double)intneg);
   LJUST_LOG(' ',(long double)shortvar);
   LJUST_LOG(' ',(long double)unsignedvar);
   LJUST_LOG(' ',(long double)longvar);
   LJUST_LOG(' ',(long double)llvar);
   LJUST_LOG(' ',(long double)ulvar);
   LJUST_LOG(' ',(long double)UX);
   LJUST_LOG(' ',(long double)1e37);

cout << "Right justified, zero padded floats" << endl;


   RJUST_LOG('0',(long double)intvar);
   RJUST_LOG('0',(long double)intneg);
   RJUST_LOG('0',(long double)shortvar);
   RJUST_LOG('0',(long double)unsignedvar);
   RJUST_LOG('0',(long double)longvar);
   RJUST_LOG('0',(long double)llvar);
   RJUST_LOG('0',(long double)ulvar);
   RJUST_LOG('0',(long double)UX);
   RJUST_LOG('0',(long double)1e37);

cout << "Right justified, space  padded floats" << endl;

   RJUST_LOG(' ',(long double)intvar);
   RJUST_LOG(' ',(long double)intneg);
   RJUST_LOG(' ',(long double)shortvar);
   RJUST_LOG(' ',(long double)unsignedvar);
   RJUST_LOG(' ',(long double)longvar);
   RJUST_LOG(' ',(long double)llvar);
   RJUST_LOG(' ',(long double)ulvar);
   RJUST_LOG(' ',(long double)UX);
   RJUST_LOG(' ',(long double)1e37);

//////////////////////////////////////////////
//////////////////////////////////////////////

cout << "=================================================" << endl;
cout << "Unjustified (long double) with precision" << endl;


cout << "Left justified, zero padded floats with precision" << endl;


   PLJUST_LOG('0',(long double)intvar);
   PLJUST_LOG('0',(long double)intneg);
   PLJUST_LOG('0',(long double)shortvar);
   PLJUST_LOG('0',(long double)unsignedvar);
   PLJUST_LOG('0',(long double)longvar);
   PLJUST_LOG('0',(long double)llvar);
   PLJUST_LOG('0',(long double)ulvar);
   PLJUST_LOG('0',(long double)UX);
   PLJUST_LOG('0',(long double)1e37);

cout << "Left justified, space  padded floats with precision " << endl;

   PLJUST_LOG(' ',(long double)intvar);
   PLJUST_LOG(' ',(long double)intneg);
   PLJUST_LOG(' ',(long double)shortvar);
   PLJUST_LOG(' ',(long double)unsignedvar);
   PLJUST_LOG(' ',(long double)longvar);
   PLJUST_LOG(' ',(long double)llvar);
   PLJUST_LOG(' ',(long double)ulvar);
   PLJUST_LOG(' ',(long double)UX);
   PLJUST_LOG(' ',(long double)1e37);

cout << "Right justified, zero padded floats with precision" << endl;


   RPJUST_LOG('0',(long double)intvar);
   RPJUST_LOG('0',(long double)intneg);
   RPJUST_LOG('0',(long double)shortvar);
   RPJUST_LOG('0',(long double)unsignedvar);
   RPJUST_LOG('0',(long double)longvar);
   RPJUST_LOG('0',(long double)llvar);
   RPJUST_LOG('0',(long double)ulvar);
   RPJUST_LOG('0',(long double)UX);
   RPJUST_LOG('0',(long double)1e37);

cout << "Right justified, space  padded floats with precision" << endl;

   RPJUST_LOG(' ',(long double)intvar);
   RPJUST_LOG(' ',(long double)intneg);
   RPJUST_LOG(' ',(long double)shortvar);
   RPJUST_LOG(' ',(long double)unsignedvar);
   RPJUST_LOG(' ',(long double)longvar);
   RPJUST_LOG(' ',(long double)llvar);
   RPJUST_LOG(' ',(long double)ulvar);
   RPJUST_LOG(' ',(long double)UX);
   RPJUST_LOG(' ',(long double)1e37);

//////////////////////////////////////////////
//////////////////////////////////////////////

   cout << "   oct(10)" << fmtd<0,0,0,8>(10) << endl;
   cout << "   hex(10)" << fmtd<0,0,0,16>(10) << endl;
   cout << "   uns(-1)" << fmtd<0,0,0,10>(unsigned(-1)) << endl;

//////////////////////////////////////////////
//////////////////////////////////////////////
cout << "String truncation of 'stuffit':" << endl;


   cout << "   3.3fmt: '" << fmtd<3,3>("stuffit") << "'" << endl;
   cout << "   3.8fmt: '" << fmtd<3,8>(std::string("stuffit")) << "'" << endl;


//////////////////////////////////////////////
//////////////////////////////////////////////


cout << "Documentation examples" << endl;

   cout << "   some text" << fmtd<20,4,'0'>(-1e8) << endl;

}
