#include <cxxtls/threadSafeHandle.h>

#include <iostream>
#include <string>
#include <stdlib.h>

using namespace std;
using namespace cxxtls;

int main()
{
   cout << "Testing thread safe handle\n";

   int *originalValue = new int(14);

   ThreadSafeHandle<int>   handle1( originalValue );

   if(handle1.referenceCount() != 1) 
   {
      cout << "error:  constructor did not work did not work -- wrt count\n";
      exit(1);
   }

   if(&*handle1 != originalValue )
   {
      cout << "error:  constructor did not work did not work -- wrt pointer contents\n";
      exit(1);
   }


   if(*handle1 != 14)
   {
      cout << "error:  operator * did not work\n";
      exit(1);
   }


   ThreadSafeHandle<int>  handle2(handle1);

   if(handle1.referenceCount() != 2) 
   {
      cout << "error:  copy constructor did not work did not work -- wrt count\n";
      exit(1);
   }

   if(handle2.referenceCount() != 2) 
   {
      cout << "error:  copy constructor did not work did not work -- wrt count\n";
      exit(1);
   }


   if(*handle2 != 14)
   {
      cout << "error:  copy constructor did not work\n";
      exit(1);
   }

   ThreadSafeHandle<int>   handle3( new int(13) );

   if(*handle3 != 13)
   {
      cout << "error:  operator * did not work\n";
      exit(1);
   }

   handle3 = handle2;

   if(handle2.referenceCount() != 3) 
   {
      cout << "error:  copy constructor did not work did not work -- wrt count\n";
      exit(1);
   }

   if(*handle3 != 14)
   {
      cout << "error:  operator= did not work\n";
      exit(1);
   }


   cout << "All tests passed!" << endl;


   return 0;
}
