
//
// Copyright 2002, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.



#include <cxxtls/file.h>

using namespace std;
using namespace cxxtls;

int main(int argc, char **argv)
{
   int options=0;
   
   if(argc < 2)
     return 0;

   if(argc > 2 && argv[2][0] == 'p')
     options|= 1; // include paths

   if(argc > 2 && argv[2][0] == 'd')
     options|= 2; // dirs only

   if(argc > 2 && argv[2][0] == 'D')
     options|= 3; // paths and dirs

   if(argc > 2 && argv[2][0] == 'n')
     options|= 4; // no dirs no paths

   if(argc > 2 && argv[2][0] == 'N')
     options|= 5; // no dirs, but paths


   FileName::sorted_names_t lf;

   FileName::find_matching(argv[1], &lf, options);

   FileName::sorted_names_t::iterator first = lf.begin(), last = lf.end();

   while(first != last)
   {
     FileStatus fs;

     first->file_stat(&fs);

     std::cout << "  " << fs.convert_to_string(true)
	       << " " << std::string(*first)
	       << std::endl;

     ++first;
   }

  return 0;

}
