#include <cxxtls/pseudoterminal.h>
#include <iostream>
#include <stdlib.h>
#include <errno.h>
#include "portable_io.h"
#include <fstream>

using namespace std;
using namespace cxxtls;

int main()
{
     PseudoTerminal pt;

     if(pt.open(false) != PseudoTerminal::good)
     {
        cout << "Error:  cannot open pseudo terminal, state is :" << pt.stateNameString() << endl;
        exit(1);
     }

     int wc = write(pt.masterFD(), "mouse\n", 6);  // make data available to a child process reading from the slave

     if(wc != 6)
     {
        int err = errno;

        cout << "Error:  cannot write 5 bytes to pseudo terminal, errno = " << err << endl;
        exit(1);
     }

#define TMPFILE  "test_pty.tmp"

     unlink(TMPFILE);

     string command = "head -1 <";

     command += pt.slaveTerminalName();

     command += " >";
     
     command += TMPFILE;

     system(command.c_str());  // execute a child process that copies stdout to stdin

     string contents;


     ifstream f(TMPFILE);

     std::getline(f, contents);

     if(contents != "mouse")
     {
         cout << "ERROR:  data not passed through pty to child properly" << endl;
         exit(1);
     }

     cout << "test successful" << endl;

     
}
