#include <cxxtls/pseudoterminal.h>
#include <iostream>
#include <stdlib.h>
#include <errno.h>
#include "portable_io.h"
#include <fstream>

using namespace std;
using namespace cxxtls;

int main()
{
     PseudoTerminal pt;

     if(pt.open(false) != PseudoTerminal::good)
     {
        cout << "Error:  cannot open pseudo terminal, state is :" << pt.stateNameString() << endl;
        exit(1);
     }

     string command = "ls -1 test_pty*.cxx >";

     command += pt.slaveTerminalName();

     system(command.c_str());  // execute a child process that copies stdout to stdin

     char buffer[10240];

     int rc = read(pt.masterFD(), buffer, sizeof(buffer));

     if(rc >= 0)
         buffer[rc] = 0;

     cout << "Read from child:  " << buffer << endl;
     
}
