#include <cxxtls/file.h>

using namespace std;
using namespace cxxtls;

int main(int argc, char **argv)
{
    //==============================================================================================
    // simple non-directory, file link
    //==============================================================================================


    {
    
       FileName  simpleFile("symlink_test_dir/symlink_file");
    
       int mode=0;
    
       FileName rv;
    
       rv = simpleFile.readlink(&mode);
    
       if(    rv.basename() != "Makefile"  
          ||  mode == 0
         )
       {
          cerr << "Error:  FileName::readlink(simpleFile,&mode) failed" << endl;
          exit(1);
       }
    
       FileMode simpleMode(mode);
    
       if(0 == (simpleMode.mode & FileMode::user_readable) )
       {
          cerr << "Error: " "symlink_test_dir/symlink_file does not seem to be readable"  << endl;
          exit(1);
       }
    
    
       if(0 == (simpleMode.mode & FileMode::link ) )
       {
          cerr << "Error: " "symlink_test_dir/symlink_file does not seem to be a symbolic link"  << endl;
          exit(1);
       }
    
       if(0 != (simpleMode.mode & FileMode::directory ) )
       {
          cerr << "Error: " "symlink_test_dir/symlink_file mistakenly seems to be a directory"  << endl;
          exit(1);
       }
    }

    //==============================================================================================
    // a link to a directory
    //==============================================================================================

    {
    
       FileName  dirFile("symlink_test_dir/symlink_dir");
    
       int mode=0;
    
       FileName rv;
    
       rv = dirFile.readlink(&mode);

       // expect to find rv contains "../subdir"

    
       if(    rv.basename() != "subdir"  
          ||  mode == 0
         )
       {
          cerr << "Error:  FileName::readlink(dirFile,&mode) failed" << endl;
          exit(1);
       }
    
       FileMode dirMode(mode);
    
       if(0 == (dirMode.mode & FileMode::user_readable) )
       {
          cerr << "Error: " "symlink_test_dir/symlink_dir does not seem to be readable"  << endl;
          exit(1);
       }
    
    
       if(0 == (dirMode.mode & FileMode::link ) )
       {
          cerr << "Error: " "symlink_test_dir/symlink_dir does not seem to be a symbolic link"  << endl;
          exit(1);
       }
    
       if(dirMode.is_dir() )
       {
          cerr << "Error: symlink_test_dir/symlink_dir mistakenly seems to be a directory"  << endl;
          cerr << "       Symbolic links to directories should not have the directory bit set" << endl;
          cerr << "       when using FileName::readlink() -- though they should when using" << endl;
          cerr << "       FileName;:file_stat()" << endl;
          exit(1);
       }
    }

  cerr << "Like Wow man!  The test like passed and stuff!" << endl;

}

