#include <cxxtls/threadGate.h>

using namespace std;

struct ThreadParm
   // parameter passed to all the worker threads
{
   ThreadGate *children;
   ThreadGate *boss;
};

CXXTLS_DECLARE_THREAD_FUNCTION(horse, parm)
{
    CXXTLS_LOG("Worker Thread is alive");

    ThreadParm *tp = reinterpret_cast<ThreadParm*>(parm);


    ThreadGate *startingGate = tp->children;

    startingGate->signal();   // I'm here at the starting lineup.

    ThreadGate *pistol = tp->boss;

    pistol->wait();           // Wait till the starting pistol is fired.

    // do something


    return 0;

}

int main()
{
    ThreadGate  started(3);
    ThreadGate  finished(1);  // boss thread will send 1 signal to the children t

    ThreadParm  tp;

    tp.children = &started;
    tp.boss     = &finished;

    CXXTLS_LOG("Boss thread creating 3 workers");

    cxxtls::ThreadId a = cxxtls::createThread(horse, &tp);
    cxxtls::ThreadId b = cxxtls::createThread(horse, &tp);
    cxxtls::ThreadId c = cxxtls::createThread(horse, &tp);

    CXXTLS_LOG("Boss thread waiting for all 3 to speak up");

    started.wait();

    CXXTLS_LOG("Boss thread sees the workers are waiting for the signal to begin work");
    CXXTLS_LOG("Life is good...");

    finished.signal(); // and there off!


    cxxtls::joinThread(a);
    cxxtls::joinThread(b);
    cxxtls::joinThread(c);

    CXXTLS_LOG("Boss thread sees all the workers are finished");

}
