#include <cxxtls/threadPool.h>
#include <iostream>
#include <stdlib.h>
#include <set>

#ifdef _MSC_VER
#define sleep(x) Sleep(1000 *x)
#endif


using namespace std;
using namespace cxxtls;


Mutex    resultsMutex;
set<int> results;


struct TestHandler
:  public  ThreadCommandHandler<int>
{
   virtual ~TestHandler() {}

   virtual bool handle(int &cmd) const
   {
       sleep(1);
       ScopedMutexLock lock(resultsMutex);
       results.insert(cmd);
       return false;
   }

};

CXXTLS_DECLARE_THREAD_FUNCTION(killer, parm)
{
   ThreadCommandHandlerPool<int>  *pool = reinterpret_cast< ThreadCommandHandlerPool<int> * >(parm);

   CXXTLS_LOG("killer() thread waiting 2 seconds before shutting down");

   sleep(2);

   CXXTLS_LOG("killer() thread invoking shutdown()");

   pool->shutdown();

   return 0;
}


int main()
{
//    CXXTLS_SET_PROGRAM_TRACE_LEVEL(TT_HEAVYDEBUG);

    cout << "test_threadPool -- is alive and kicking" << endl;

    {
        TestHandler handler;

        ThreadCommandHandlerPool<int>  pool(&handler, 9);

        pool.push(100);
        pool.push(200);
        pool.push(300);
        pool.push(400);
        pool.push(500);
        pool.push(600);
        pool.push(700);
        pool.push(800);
        pool.push(900);

        ThreadId killerId = createThread(killer, &pool);

        pool.waitForShutdown();

        CXXTLS_LOG("thread queue empty flag is is " << pool.empty());

        joinThread(killerId);

    }

    // threading has terminated

    CXXTLS_FOREACH(int cur, results)
    {
       cout << "test_threadPool message: " << cur << endl;
    }

    cout << "test_threadPool -- terminating" << endl;


}

